clc
clear all
close all
format long

 % Example 1: Chui Mhaskar van der Walt 2016
P=4;
 a=[4.9;0.96;0.92;0.90;1.0;5.0]; % frequency parameters
 b=[0;0;0;0;0;0];                % shift parameters
 g=[1;1;1;2;2;1];                % amplitudes
[a1,I]=sort(a); 
b1=b(I); 
g1=g(I);
% plot of the signal 
x=0:0.01:P;
y=statio(g1,a1,b1,x);
figure
abb=plot(x,y);
set(abb,'linewidth',2); axis([0,P,-8,8]); set(gca,'fontsize',18); print -depsc bsp1.eps;

%Example 2
% P=1;
% a=[sqrt(89); sqrt(29); sqrt(21);sqrt(2); sqrt(3); 4.0]; % frequency parameters
% b=[0.5;0.7;0;0.2;0.3;0.2];                             % shift parameters
% g=[0.5;3;2;1;2;1];                                      % amplitudes 
% [a1,I]=sort(a);
% b1=b(I);
% g1=g(I);
% % plot of the signal
% x=0:0.001:4;  %plot on interval [0,4]
% y=statio(g,a,b,x);
% figure
% abb=plot(x,y);
% set(abb,'linewidth',2); axis([0,4,-10,10]); set(gca,'fontsize',18); print -depsc bsp2.eps;



Z=(1:40)';  % number of used Fourier coefficients
[L,~]=size(Z)

% Computation of Fourier coefficients c_n (n=1...L) for the example
[K,~]=size(a);
F=zeros(L,1);
for n=1:K
    if imag(a(n))==0 && abs(mod(a(n).*P,1))<0.0000001 
            aa=round(a(n).*P);
        v=zeros(L,1); v(aa)=1;
        F= F+g(n).*(cos(b(n))- 1i.*sin(b(n))).*v./2;
    else
    F = F+(sin(a(n).*pi.*P).*g(n))./(pi.*((a(n).*P)^2-Z.^2)).*(P.*a(n).* cos(a(n).*pi.*P+b(n))- i*Z.*sin(a(n).*pi.*P+b(n)));
    end
end;
eps=10^(-10);
[g,a,b,pol,zer,z,f,w,errvec]=aaanonper1(F,Z,P,eps,20); % g,a,b are the reconstructed parameter vectors
[a,I]=sort(a); % sort reconstructed parameters
a=a
b=b(I);
J=find(abs(b-2*pi)<10^(-7));
b(J)=b(J)-2*pi
g=g(I)
z=z
errvec=errvec
% compute the error 
errora=norm(a-a1,inf)
errorb=norm(b-b1,inf)
errorg=norm(g-g1,inf)



function f=statio(g1,a1,b1,x)
[N,~]=size(g1)
f=0;
for k=1:N
f= f+ g1(k)*cos(2*pi*a1(k)*x+b1(k));
end
end